#ifndef __MMAPPER_H__
#define __MMAPPER_H__ 1

#include "Mapper.h"
#include "AllocArray.h"
#include <stdio.h>

class MMapper : public Mapper {
 public:
  MMapper(char* meta);
  ~MMapper();

  virtual AllocArray<unsigned int>* getDims();
  virtual float getFloat(AllocArray<unsigned int>& coords);
  virtual int getInt(AllocArray<unsigned int>& coords);
  //virtual int isValid();
  //void* vector();
  virtual float getFloat(unsigned int coord);
  virtual int getInt(unsigned int coord);
  virtual void getFloat
    (float* buffer, unsigned int coord, unsigned int count);
  virtual void getInt
    (int* buffer, unsigned int coord, unsigned int count);
  virtual void getFloat
    (float* buffer, unsigned int coord, unsigned int count,
     unsigned int skip);
  virtual void getInt
    (int* buffer, unsigned int coord, unsigned int count,
     unsigned int skip);
  virtual unsigned int getSize();
  virtual float getMin();
  virtual float getMax();
  virtual void close();
  virtual void open();
  virtual int isOpen();
  virtual AllocArray<unsigned int>* getOriginalDims();
  virtual unsigned int getSplitTotal();

 private:
  char* fn;
  FILE* file;
  float* arrayf;
  int* arrayi;
  //int valid;
  size_t end;
  size_t size;
  size_t skip;
  AllocArray<unsigned int> dims;
  AllocArray<unsigned int> first;
  AllocArray<unsigned int> last;
  AllocArray<unsigned int> oridims;
  unsigned int splittotal;

  float min;
  float max;
};

#endif
